<?php
/**
 * ConstantManager file
 *
 * @category  UPS_Shipping
 * @package   UPS_Shipping
 * @author    United Parcel Service of America, Inc. <noreply@ups.com>
 * @copyright 2019 United Parcel Service of America, Inc., all rights reserved
 * @license   This work is Licensed under the License and Data Service Terms available
 * at: https://www.ups.com/assets/resources/media/ups-license-and-data-service-terms.pdf
 * @link      https://www.ups.com/pl/en/services/technology-integration/ecommerce-plugins.page
 */
namespace UPS\Shipping\Helper;

/**
 * ConstantManager class
 *
 * @category  UPS_Shipping
 * @package   UPS_Shipping
 * @author    United Parcel Service of America, Inc. <noreply@ups.com>
 * @copyright 2019 United Parcel Service of America, Inc., all rights reserved
 * @license   This work is Licensed under the License and Data Service Terms available
 * at: https://www.ups.com/assets/resources/media/ups-license-and-data-service-terms.pdf
 * @link      https://www.ups.com/pl/en/services/technology-integration/ecommerce-plugins.page
 */
class ConstantManager
{
    const MERCHANTKEY = 'merchantKey';
    const ACCOUNTNUMBER = 'accountNumber';
    const STATUS = 'status';
    const BEARERTOKEN = 'bearerToken';
    const ACCESSORIALS = 'accessorials';
    const ACCESSORIAL_KEY = 'accessorial_key';
    const ACCESSORIAL_NAME = 'accessorial_name';
    const PACKAGE_NAME = 'package_name';
    const WEIGHT = 'weight';
    const UNIT_WEIGHT = 'unit_weight';
    const WEIGHTUNIT = 'weightUnit';
    const LENGTH = 'length';
    const WIDTH = 'width';
    const HEIGHT = 'height';
    const UNIT_DIMENSION = 'unit_dimension';
    const DIMENSIONUNIT = 'dimensionUnit';
    const DELIVERYRATES = 'deliveryRates';
    const SERVICE_KEY_DELIVERY = 'service_key_delivery';
    const RATE_TYPE = 'rate_type';
    const SERVICETYPE = 'serviceType';
    const SERVICE_TYPE = 'service_type';
    const SERVICE_NAME = 'service_name';
    const SERVICENAME = 'serviceName';
    const SERVICECODE = 'serviceCode';
    const RATE_CODE = 'rate_code';
    const MIN_ORDER_VALUE = 'min_order_value';
    const DELIVERY_RATE = 'delivery_rate';
    const REALTIMEVALUE = 'realtimeValue';
    const SHIPPINGSERVICES = 'shippingServices';
    const COMPANYNAME = 'companyName';
    const DMY = 'd/m/Y';
    const MDY = 'm/d/Y';
    const WEBSITE = 'website';
    const CURRENCYCODE = 'currencyCode';
    const PLATFORM = 'platform';
    const VERSION = 'version';
    const ADDRESS = 'address';
    const POSTALCODE = 'postalCode';
    const COUNTRY = 'country';
    const ISFIRSTACCOUNT = 'isFirstAccount';
    const SHIPMENTID = 'shipmentId';
    const ISCASHONDELIVERY = 'isCashOnDelivery';
    const PRODUCTS = 'products';
    const TRACKINGNUMBER = 'trackingNumber';
    const SHIPMENTSTATUS = 'shipmentStatus';
    const CITY = 'city';
}
